/* This program handles the terminal emulation between the Genesis development
   board and the IBM PC. It can also read a script file and process commands.*/
#define MAXSIZE 8192
#define TIME 9000
#define BUFF 8192

int data,ip,op;
int file;
extern long lseek();
extern long fseek();
long lastloc;
long sum;
long rsum;
char text[80];
char infile[MAXSIZE],*inp,*thisline;
char buffer[BUFF];
char *PORTNAME="GPORT";
char exitflag=0;
char goflag=0;
int (*bout)();
int (*bin)();
int (*state)();

#define isstop(val) (val==' ' || val==9 || val==10 || val==13 || val==',')


long filelen(name)
char *name;
{
	long len;
	int f;

	f=fopen(name,"r");
	if(!f) return 0L;
	len=lseek(f,0L,2);
	fclose(f);
	return len;
}

long fetchhex()
{
	long temp;
	char ch;

	temp=0;
	while()
	{
		ch=toupper(*inp++);
		if(ch>='0' && ch<='9') {temp<<=4;temp+=ch-'0';continue;}
		if(ch>='A' && ch<='F') {temp<<=4;temp+=ch-'A'+10;continue;}
		break;
	}
	--inp;
	return temp;
}


int lout(val)
long val;
{
	bout(val>>24);
	bout(val>>16);
	bout(val>>8);
	return(bout(val));
}
int lin(along)
char *along;
{
	along+=3;
	bin(along--);
	bin(along--);
	bin(along--);
	return(bin(along));
}


state3()
{
	if(in(ip)&64) return(1);
	return(0);
}
bout3(val)
int val;
{
putchar('.');
#asm
	mov	al,[bp+4]
	and	al,15
	mov	dx,word data_
	out	dx,al
	inc	dx
	inc	dx
	mov	al,1
	out	dx,al
	mov	cx,9000
	dec	dx
bo31:
	in	al,dx
	and	al,64
	jz	bo31o
	loop	bo31
	jmp	bo3bad
bo31o:
	inc	dx
	xor	al,al
	out	dx,al
	mov	cx,9000
	dec	dx
bo32:
	in	al,dx
	and	al,64
	jnz	bo32o
	loop	bo32
	jmp	bo3bad
bo32o:
	dec	dx
	mov	al,[bp+4]
	mov	cl,4
	shr	al,cl
	or	al,16
	out	dx,al
	inc	dx
	inc	dx
	mov	al,1
	out	dx,al
	mov	cx,9000
	dec	dx
bo33:
	in	al,dx
	and	al,64
	jz	bo33o
	loop	bo33
	jmp	bo3bad
bo33o:
	inc	dx
	mov	al,20h
	out	dx,al
	dec	dx
	mov	cx,9000
bo34:
	in	al,dx
	and	al,64
	jnz	bo34o
	loop	bo34
	jmp	bo3bad
bo3bad:
	mov	dx,word op_
	mov	al,20h
	out	dx,al
	mov	ax,1
	jmp	bo3x
bo34o:
bo3good:
	xor	ax,ax
bo3x:
#endasm
}
bin3(loc)
char *loc;
{
#asm
	mov	dx,word ip_
	mov	cx,9000
bi31:
	in	al,dx
	and	al,64
	jz	bi31o
	loop	bi31
	jmp	bi3bad
bi31o:
	dec	dx
bi3r1:
	in	al,dx
	mov	bh,al
	in	al,dx
	cmp	al,bh
	jnz	bi3r1
	in	al,dx
	cmp	al,bh
	jnz	bi3r1

	xor	bl,bl
	and	al,16
	jnz	bi3skip1
	mov	bl,bh
	xor	bl,al

	inc	dx
	inc	dx
	mov	al,21h
	out	dx,al
	dec	dx
	mov	cx,9000
bi32:
	in	al,dx
	and	al,64
	jnz	bi32o
	loop	bi32
	jmp	bi3bad
bi32o:
	inc	dx
	mov	al,20h
	out	dx,al

bi3skip1:

	mov	dx,word ip_
	mov	cx,9000
bi33:
	in	al,dx
	and	al,64
	jz	bi33o
	loop	bi33
	jmp	bi3bad
bi33o:
	dec	dx
bi3r2:
	in	al,dx
	mov	bh,al
	in	al,dx
	cmp	al,bh
	jnz	bi3r2
	in	al,dx
	cmp	al,bh
	jnz	bi3r2

	and	al,16
	jz	bi3skip2
	mov	cl,4
	sal	bh,cl
	or	bl,bh

	inc	dx
	inc	dx
	mov	al,21h
	out	dx,al
	dec	dx
	mov	cx,9000
bi34:
	in	al,dx
	and	al,64
	jnz	bi34o
	loop	bi34
	jmp	bi3bad
bi3bad:
	mov	dx,word op_
	mov	al,20h
	out	dx,al

	mov	ax,1
	jmp	bi3x
bi34o:
	inc	dx
	mov	al,20h
	out	dx,al
bi3skip2:
	mov	di,[bp+4]
	mov	[di],bl
bi3good:
	xor	ax,ax
bi3x:
#endasm
}



bout0(val)
int val;
{
#asm
	mov	al,[bp+4]
	mov	bx,word sum_
	mov	dx,word sum_+2
	xor	bl,al
	shl	bx,1
	rcl	dx,1
	jnc	noadd1
	inc	bx
noadd1:
	mov	word sum_,bx
	mov	word sum_+2,dx
	mov	dx,word data_
	out	dx,al
	inc	dx
	inc	dx
	mov	al,1
	out	dx,al
	mov	cx,9000
	dec	dx
b1:
	in	al,dx
	and	al,64
	jz	b1o
	loop	b1
	jmp	b0
b1o:
	inc	dx
	mov	al,20h
	out	dx,al
;	mov	al,255
;	dec	dx
;	dec	dx
;	out	dx,al
	mov	cx,9000
	inc	dx
b2:
	in	al,dx
	and	al,64
	jnz	b2o
	loop	b2
b0:
	mov	dx,word op_
	mov	al,20h
	out	dx,al
;	dec	dx
;	dec	dx
;	mov	al,255
;	out	dx,al
	mov	ax,1
	jmp	bd
b2o:
	xor	ax,ax
bd:
#endasm
}
bin0(loc)
char *loc;
{
#asm
	mov	dx,word data_
	inc	dx
	mov	cx,9000
bi1:
	in	al,dx
	and	al,64
	jz	bio1
	loop	bi1
	jmp	bibad
bio1:
	dec	dx
r:
	in	al,dx
	mov	ah,al
	in	al,dx
	cmp	al,ah
	jnz	r
	in	al,dx
	cmp	al,ah
	jnz	r
	mov	di,[bp+4]
	mov	[di],al

	mov	bx,word rsum_
	mov	cx,word rsum_+2
	xor	bl,al
	shl	bx,1
	rcl	cx,1
	jnc	noadd1b
	inc	bx
noadd1b:
	mov	word rsum_,bx
	mov	word rsum_+2,cx

	inc	dx
	inc	dx
	mov	al,21h
	out	dx,al
	dec	dx
	mov	cx,9000
bi2:
	in	al,dx
	and	al,64
	jnz	bio2
	loop	bi2
bibad:
	inc	dx
	mov	al,20h
	out	dx,al
	mov	ax,1
	jmp	bidone
bio2:
	inc	dx
	mov	al,20h
	out	dx,al
	xor	ax,ax
bidone:
#endasm
}
state0()
{
	if(in(ip)&64) return(1);
	return(0);
}

bout1(val)
int val;
{
#asm
	mov	al,[bp+4]
	mov	bx,word sum_
	mov	dx,word sum_+2
	xor	bl,al
	shl	bx,1
	rcl	dx,1
	jnc	noadd2
	inc	bx
noadd2:
	mov	word sum_,bx
	mov	word sum_+2,dx
	mov	dx,word data_
	out	dx,al
	inc	dx
	inc	dx
	mov	al,1
	out	dx,al
	xor	al,al
	out	dx,al

	mov	cx,9000
	dec	dx
b12:
	in	al,dx
	and	al,16
	jnz	b1o2
	loop	b12

	mov	dx,word op_
	mov	al,20h
	out	dx,al
;	dec	dx
;	dec	dx
;	mov	al,255
;	out	dx,al
	mov	ax,1
	jmp	bd2
b1o2:
	inc	dx
	mov	al,20h
	out	dx,al
;	dec	dx
;	dec	dx
;	mov	al,255
;	out	dx,al
	xor	ax,ax
bd2:
#endasm
}

bin1(loc)
char *loc;
{
#asm
	mov	dx,word data_
	inc	dx
	mov	cx,9000
bi12:
	in	al,dx
	and	al,32
	jz	bio12
	loop	bi12
	inc	dx
	mov	al,20h
	out	dx,al
	mov	ax,1
	jmp	bidone2
bio12:
	dec	dx
r2:
	in	al,dx
;	mov	ah,al
;	in	al,dx
;	cmp	al,ah
;	jnz	r2
;	in	al,dx
;	cmp	al,ah
;	jnz	r2
	mov	di,[bp+4]
	mov	[di],al

	mov	bx,word rsum_
	mov	cx,word rsum_+2
	xor	bl,al
	shl	bx,1
	rcl	cx,1
	jnc	noadd1b2
	inc	bx
noadd1b2:
	mov	word rsum_,bx
	mov	word rsum_+2,cx

	inc	dx
	inc	dx
	mov	al,21h
	out	dx,al
	dec	al
	out	dx,al
	xor	ax,ax
bidone2:
#endasm
}
state1()
{
	if(in(ip)&32) return(1);
	return(0);
}
bout2(val)
int val;
{
#asm
	mov	al,[bp+4]
	mov	bx,word sum_
	mov	dx,word sum_+2
	xor	bl,al
	shl	bx,1
	rcl	dx,1
	jnc	noadd22
	inc	bx
noadd22:
	mov	word sum_,bx
	mov	word sum_+2,dx
	mov	dx,word data_

	out	dx,al
	inc	dx

	mov	cx,9000
b13:
	in	al,dx
	and	al,8
	jnz	b1o3
	loop	b13

	mov	ax,1
	jmp	bd3
b1o3:
	xor	ax,ax
bd3:
#endasm
}

bin2(loc)
char *loc;
{
#asm
	mov	dx,word data_
	inc	dx
	mov	di,[bp+4]
	mov	cx,9000
bi13:
	in	al,dx
	and	al,4
	jz	bio13
	loop	bi13
	mov	ax,1
	jmp	bidone3
bio13:
	dec	dx
	in	al,dx
	mov	[di],al

	mov	bx,word rsum_
	mov	cx,word rsum_+2
	xor	bl,al
	shl	bx,1
	rcl	cx,1
	jnc	noadd1b3
	inc	bx
noadd1b3:
	mov	word rsum_,bx
	mov	word rsum_+2,cx

	xor	ax,ax
bidone3:
#endasm
}
state2()
{
	if(in(ip)&4) return(1);
	return(0);
}


command(ch)
char ch;
{
	bout('D');
	bout('A');
	bout('V');
	bout('E');
	return(bout(ch));
}


in(port)
	int port;
{
#asm
	 mov dx,[bp+4]
	 in al,dx
	 xor ah,ah
#endasm
}
out(port,val)
	int port,val;
{
#asm
	 mov dx,[bp+4]
	 mov ax,[bp+6]
	 out dx,al
#endasm
}

myci()
{
#asm
	mov	ah,0bh
	int	21h
	or	al,al
	jz	nochar
	mov	ah,7
	int	21h
nochar:
	xor	ah,ah
#endasm
}

kr()
{
#asm
	mov ah,1
	int 22
	mov ax,0
	jz nokey
	dec	ax
nokey:
#endasm
}

rci()
{
#asm
	mov ax,0
	int 22
#endasm
}

rqual()
{
#asm
	mov	ah,2
	int	22
	mov	ah,0
#endasm
}
wci()
{
	int ch,q;

	ch=rci();
	q=rqual();

	if(!(ch & 0xff)) ch=(ch>>8)+0x100;
	else ch&=0xff;
	if((q&3) && ch>=0x100) ch+=0x200; /* shift keys */
	if(ch==0x0d) ch=0x0a;
	return ch;
}



getpbase()
{
#asm
	push ds
	mov ax,40h
	mov	ds,ax
	mov	ax,ds:[8]
	pop ds
#endasm
}

int send(pntr,len)
char *pntr;
int len;
{
	int v;
	while(len--) if(v=bout(*pntr++)) break;
	return v;
}

int hextoi(string)
char *string;
{
	int val;
	char ch;

	val=0;
	while(ch=*string++)
	{
		ch=tolower(ch);
		if(ch>='0' && ch<='9') {val<<=4;val+=ch-'0';}
		else if(ch>='a' && ch<='f') {val<<=4;val+=ch-'a'+10;}
		else break;
	}
	return val;
}

sendfile(str)
char *str;
{
	int f;
	int len;
	char *p;

	f=fopen(str,"r");
	if(!f) return 1;
	while()
	{
		p=buffer;
		len=fread(p,1,BUFF,f);
		if(!len) break;
		while(len--) bout(*p++);
	}
	fclose(f);
}

sendpart(file,len)
int file;
long len;
{
	char *p;
	int k,l;

	while(len)
	{
		p=buffer;
		k=len>BUFF ? BUFF : len;
		l=fread(p,1,k,file);
		if(!l) break;
		len-=l;
		while(l--) bout(*p++);
	}
}
long readlong(file)
int file;
{
	long val1,val2;
	char *p1,*p2;

	val1=0;
	p1=&val1;
	fread(p1,4,1,file);
	p1+=3;
	p2=&val2;
	*p2++=*p1--;
	*p2++=*p1--;
	*p2++=*p1--;
	*p2=*p1;
	return val2;
}

main(argc,argv)
int argc;
char *argv[];
{
	int ch;
	long	val;
	int len;
	int btype;
	int i;

	if(findenv(text,PORTNAME))
	{
		btype=0;
		inp=text;
		data=fetchhex();
		if(*inp++==',')
		{
			btype=*inp&7;
		}

		switch(btype)
		{
		case 1:
			bout=bout1;
			bin=bin1;
			state=state1;
			break;
		case 2:
			bout=bout2;
			bin=bin2;
			state=state2;
			break;
		case 3:
			bout=bout3;
			bin=bin3;
			state=state3;
			break;
		default:
			bout=bout0;
			bin=bin0;
			state=state0;
			break;
		}
	} else
	{
		printf("Please set the parallel port number in your environment.\n");
		printf("set %s=<hex number>\n",PORTNAME);
		printf("or\nset %s=<hex number>,1 for new version of board\n",PORTNAME);
		return 1;
	}

	ip=data+1;
	op=data+2;
	out(op,0x20);

for(i=0;i<100;i++)
{
printf("data:(%x)=%x\n",data,in(data));
printf("stat:(%x)=%x\n",ip,in(ip));
}
return;

/*	out(data,0xff);*/

	lout(0L);

	exitflag=0;
	goflag=0;
	if(argc>1)
	{
		file=fopen(argv[1],"r");
		if(!file) {puts("Cannot open command file.\n");return;}
		len=fread(infile,1,MAXSIZE-1,file);
		fclose(file);
		inp=infile;
		infile[len]=0;
		lastloc=0;
		processall();
		if(exitflag) goto nicequit;
	}

	if(!goflag) if(command('d')) timeout();

	while()
	{
		if(kr())
		{
			ch=wci();
			if(ch<256)
			{
				if(ch==0x1b) break;
				if(ch==3) goto nicequit;
				bout(ch);
			} else
			{
				if(ch>=0x13b && ch<0x145)
					bout(ch-0x13b+0x80);
				else if(ch==0x153) issue(); /* del key */
			}
		}
		if(!state())
		{
			if(!bin(&ch))
				putchar(ch);
		}
	}
	bout(0xda);
nicequit:
	return 0;
abort:
	out(op,0x20);
	puts("Timeout.\n");
	puts("Reset Sega, check cables, and try again.\n");
	puts("Perhaps try powering the Sega off then back on.\n");
	return 1;
}

issue()
{
char iline[128];

	bout(0xda);
	putchar('\n');
	while()
	{
		puts("* ");
		fetchline(iline);
		if(iline[0]==10) break;
		inp=iline;
		processall();
	}
	command('d');
}

fetchline(ln)
char *ln;
{
char *ln2;
int ch;

	ln2=ln;
	while()
	{
		ch=wci();
		if(ch>=0x100) continue;
		if(ch==8)
		{
			if(ln2>ln) {putchar(ch);putchar(' ');putchar(ch);ln2--;}
		} else if(ch==10) break;
		else if(ch==0x1b) {ln2=ln;break;}
		else
		{
			if(ln2>ln+120) continue;
			*ln2++=ch;
			putchar(ch);
		}
	}
	putchar('\n');
	*ln2++=10;
	*ln2=0;
}

token(str)
char *str;
{
	char ch;

	while()
	{
		ch=*inp++;
		if(!ch || ch==';' || isstop(ch)) break;
		*str++=ch;
	}
	--inp;
	*str=0;
	return ch;
}

dogo()
{
	long loc;
	char *inpsave;

	inpsave=inp;
	loc=fetchhex();
	if(inp==inpsave)
	{
		loc=-1L;
		puts("GO\n");
	} else
		printf("GO:%lx\n",loc);
/*	lout(0L);*/
	if(command('G')) {timeout();return 0;}
	if(lout(loc)) {timeout();return 0;}
	goflag=1;
	return 0;
}

doexit()
{
	puts("EXIT\n");
	exitflag=1;
	return 0;
}
doinit()
{
	if(command('i')) {timeout();return 0;}
}

doedit()
{
	long loc;
	int count=0,i;

	loc=fetchhex();
	while(*inp==',')
	{
		inp++;
		buffer[count++]=fetchhex();
	}
	printf("EDIT:%06lx ",loc);
	for(i=0;i<count;i++)
		printf(" %02x",buffer[i]);
	putchar('\n');
	if(command('l')) {timeout(); return 0;}
	if(lout(loc)) {timeout(); return 0;}
	if(lout((long)count)) {timeout();return 0;}
	sum=0;
	if(send(buffer,count)) {timeout();return 0;}
	check("data");
	return 0;
}

doread()
{
	char ch;
	long loc,len;
	int file;
	int count;
	char *p1;

	token(text);
	if(comma()) return 1;
	loc=fetchhex();
	if(comma()) return 1;
	len=fetchhex();
	file=fopen(text,"w");
	if(!file) {printf("Cannot open %s for output.\n",text);return 1;}
	if(command('r')) {fclose(file);timeout(); return 1;}
	if(lout(loc)) {fclose(file);timeout(); return 1;}
	if(lout(len)) {fclose(file);timeout(); return 1;}
	printf("READ:%s,%lx,%lx\n",text,loc,len);
	count=0;
	p1=buffer;
	rsum=0;
	while(len--)
	{
		if(bin(p1++)) {fclose(file);timeout();return 0;}
		count++;
		if(count==256 && len)
		{
			fwrite(buffer,1,count,file);
			p1=buffer;
			count=0;
			if(bout('g')) {fclose(file);timeout();return 0;}
		}
	}
	if(count) fwrite(buffer,1,count,file);
	fclose(file);
	sum=rsum;
	check(text);
	return 0;
}
doload()
{
	char ch;
	long loc;
	long len;

	ch=token(text);
	len=filelen(text);
	if(len==0) {printf("Error in loading %s\n",text);return 1;}
	if(ch==',')
	{
		++inp;
		loc=fetchhex();
		lastloc=loc+len;
	} else
	{
		loc=lastloc;
		len+=4;
		lastloc+=len;
		if(lastloc&1) lastloc++;
	}

	printf("LOAD:%s,%lx-%lx\n",text,loc,loc+len);

	if(command('l')) {timeout();return 1;}
	if(lout(loc)) {timeout();return 1;}
	if(lout(len)) {timeout();return 1;}
	sum=0;

	if(ch!=',')
	{
		if(lout((len+1L)&0xfffffeL)) {timeout();return 1;}
		len-=4;
	}

	if(sendfile(text)) {timeout();return 1;}
	check(text);
	return 0;
}

doloadx()
{
	long	c,v1,v2,v3,v4;
	int numhunks,i,j,hc;
	long	lens[64];
	long offs[64];
	char	name[128];
	long loc;
	long len;
	char *p,ch,c2;

	int file;

	ch=token(text);
	file=fopen(text,"r");
	if(!file) {printf("Cannot open %s\n",text);return 1;}
	if(ch==',')
	{
		++inp;
		loc=lastloc=fetchhex();
	}
	loc=lastloc;

	while()
	{
		c=readlong(file);
		switch(c)
		{
		case	0x3f3: /* hunk_header */
			readlong(file); /* libraries */
			numhunks=readlong(file);
			readlong(file);
			readlong(file);
			i=0;
			v1= ch==',' ? loc : loc+4;
			len= ch==',' ? 0 : 4;
			while(i<numhunks)
			  {v2=readlong(file)<<2;lens[i]=v2;offs[i++]=v1;v1+=v2;len+=v2;}
			lastloc+=len;if(lastloc&1) lastloc++;
			if(command('l')) {timeout();fclose(file);return 1;}
			if(lout(loc)) {timeout();fclose(file);return 1;}
			if(lout(len)) {timeout();fclose(file);return 1;}
			printf("LOADX:%s,%lx-%lx\n",text,loc,loc+len);
			sum=0;
			if(ch!=',') if(lout((len+1)&0xfffffeL)) {timeout();fclose(file);return 1;}
			hc=-1;
			break;
		case 0x3e9: /* hunk_code */
		case 0x3ea: /* hunk_data */
			hc++;
			v1=readlong(file);
			sendpart(file,v1<<2);
			if(hc+1==numhunks) check(text);
			break;
		case 0x3f2: /* hunk_end */
			break;
		case 0x3f0:
			while(v1=readlong(file))
			{
				p=name;
				v1<<=2;
				fread(p,1,(int)v1,file);
				name[v1]=0;
				v1=readlong(file);
				if(command('s')) timeout();
				do bout(*p);while(*p++);
				if(lout(v1+offs[hc])) timeout();
				i=50;
				while(i--)
					if(!bin(&c2) && c2=='A') break;
				if(!i) timeout();
			}
		case 0:
			goto xldone;
		}
	}
xldone:
	fclose(file);
	return 0;
}
doreset()
{
	command('R');
	puts("RESET\n");
	return 0;
}
doreg(str)
char *str;
{
	long val;
	if(command('z')) {timeout();return 1;}
	bout(*str++);
	bout(*str++);
	val=fetchhex();
	lout(val);
	str-=2;
	putchar(toupper(*str++));
	putchar(toupper(*str++));
	printf("=%lx\n",val);
	return 0;
}


char *ftab[]=
{
"go",dogo,
"load",doload,
"loadx",doloadx,
"reset",doreset,
"read",doread,
"exit",doexit,
"edit",doedit,
"init",doinit,
"d0",doreg,
"d1",doreg,
"d2",doreg,
"d3",doreg,
"d4",doreg,
"d5",doreg,
"d6",doreg,
"d7",doreg,
"a0",doreg,
"a1",doreg,
"a2",doreg,
"a3",doreg,
"a4",doreg,
"a5",doreg,
"a6",doreg,
"a7",doreg,
"sp",doreg,
"pc",doreg,
0
};


timeout(){puts("Timeout\n");}

processall()
{
char ch;

	exitflag=0;
	while(*inp)
	{
		thisline=inp;
		ch=token(text);
		if(text[0]) process(text);
		if(exitflag) break;
		skipcr();
	}
	return exitflag;
}

process(str)
char *str;
{
	int (*func)();
	int *ptr;

	ptr=ftab;

	while()
	{
		if(!*ptr) break;
		if(strcmp(str,*ptr++)) ptr++;
		else
		{
			func=*ptr;
			skipwhite();
			if((func)(str))
			{
				while(*thisline)
				{
					putchar(*thisline);
					if(*thisline++==10) break;
				}
			}
			break;
		}
	}
}
skipcr()
{
	char ch;
	while() {ch=*inp++;if(!ch) {--inp;break;} if(ch==10) break;}
}
skipwhite()
{
	while(*inp==' ' || *inp==9) inp++;
}
check(str)
char *str;
{
	long val;

	val=0;
	if(lin(&val)) {timeout();return 1;}
	if(val!=sum) printf("Error during transmission of %s\n",str);
	return val!=sum;
}

/* look is pointer to string, like "path" */
/* rets is pointer to where to store */
/* returns 1 if successful, otherwise 0 */
findenv(rets,look)
char *rets,*look;
{
#asm
cstart:
	mov ah,62h
	int 21h
	mov es,bx
	mov ax,word es:[2ch]
	mov es,ax
	xor si,si
check:
	mov di,[bp+6]
comploop:
	mov al,byte [di]
	call	tupper
	mov	ah,al
	mov al,byte es:[si]
	call tupper
	cmp	ax,'='
	jz	found
	cmp	ah,al
	jnz failcheck
	inc	si
	inc	di
	jmp comploop
failcheck:
	mov al,byte es:[si]
	inc si
	or al,al
	jnz failcheck
	mov al,byte es:[si]
	or al,al
	jnz check
	xor ax,ax
	jmp back
tupper:
	cmp al,'a'
	jc tupret
	cmp al,'z'+1
	jnc tupret
	sub al,20h
tupret:
	ret
found:
	mov di,[bp+4]
	inc	si
movl:
	mov al,byte es:[si]
	mov byte [di],al
	inc si
	inc di
	or al,al
	jnz movl
	mov ax,1
back:
#endasm
}
comma()
{
	if(*inp++==',') return 0;
	--inp;
	puts("Syntax error");
	return 1;
}
