/* this program filters the xband log data */
/* It accepts an ascii line where each line looks like:
2:  3590 15:37:43 Regurg: master=1  magic=33  when=0x2f96e017 (Thu Apr 20 15:28:39 1995)
^^^^^^^^
If a line contains $4d1c4e1d we want to look at the first 8 characters of that line,
then every line of the file that begins with those 8 characters should be stuffed into
a file.
*/

#define BUFFSIZE 4096

typedef int FILE;

char inbuff[BUFFSIZE];
char outbuff[BUFFSIZE];
char *inp;
char *outp;
int inleft;
int outleft;
FILE infile,outfile;

initio()
{
	inp=inbuff;
	outp=outbuff;
	inleft=0;
	outleft=0;
	lseek(infile,0L,0);
}

fci()
{
	if(!inleft)
	{
		inleft=read(infile,inbuff,BUFFSIZE);
		if(!inleft) return -1;
		inp=inbuff;
	}
	inleft--;
	return *inp++;
}
flush()
{
	write(outfile,outbuff,outleft);
	outleft=0;
	outp=outbuff;
}
fco(ch)
char ch;
{
	*outp++=ch;
	outleft++;
	if(outleft==BUFFSIZE) flush();
}

main(argc,argv)
int argc;
char *argv[];
{
int ch;
int mode;
char lines[1024][8];
int linecount;
int i,j;
char aline[8];
char *p1,*p2;

	infile=fopen(argv[1],"r");
	if(!infile) {puts("cannot open input file\n");return;}
	outfile=fopen(argv[2],"w");
	if(!outfile) {puts("cannot open output file\n");fclose(infile);return;}

	initio();

	linecount=0;
	i=0;mode=0;
	while()
	{
		ch=fci();
		if(ch<0) break;
		if(ch==13 || ch==10) {mode=0;i=0;continue;}
		switch(mode)
		{
		case 0:
			lines[linecount][i++]=ch;
			if(i==8) {i=0;mode=1;}
			break;
		case 99:
			break;
		case 1:
			if(ch=='4') mode=2; else mode=1;
			break;
		case 2:
			if(ch=='d') mode=3; else mode=1;
			break;
		case 3:
			if(ch=='1') mode=4; else mode=1;
			break;
		case 4:
			if(ch=='c') mode=5; else mode=1;
			break;
		case 5:
			if(ch=='4') mode=6; else mode=1;
			break;
		case 6:
			if(ch=='e') mode=7; else mode=1;
			break;
		case 7:
			if(ch=='1') mode=8; else mode=1;
			break;
		case 8:
			mode=99;
			if(ch!='d') break;
			linecount++;
			break;
		}
	}
printf("%d record",linecount);if(linecount>1) putchar('s');putchar('\n');

	initio();

	i=0;mode=0;
	while()
	{
		ch=fci();
		if(ch<0) break;
		if(ch==13) continue;
		switch(mode)
		{
		case 0:
			if(ch==10) {mode=0;i=0;break;}
			aline[i++]=ch;
			if(i==8)
			{
				for(j=0;j<linecount;j++)
				{
					p1=aline;
					p2=lines[j];
					for(i=0;i<8;i++)
						if(*p1++!=*p2++) break;
					if(i==8) break;
				}
				if(j<linecount)
				{
					for(i=0;i<8;i++) fco(aline[i]);
					mode=1;
				} else mode=2;
			}
			break;
		case 1:
			fco(ch);
			if(ch==10) {mode=0;i=0;}
			break;
		case 2:
			if(ch==10) {mode=0;i=0;}
			break;
		}
	}

	flush();
 	fclose(infile);
	fclose(outfile);
}
